import java.io.File;
import java.util.Collection;

import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.firefox.FirefoxDriver;

import com.googlecode.fightinglayoutbugs.*;

public class FightingBugs {
	public static void main(String[] args)
	{
	     FirefoxDriver driver = new FirefoxDriver();
	     // ChromeDriver driver = new ChromeDriver();
	    try {
	        String testPageUrl = "http://localhost/valid_but_bugs/index.html";
	        driver.get(testPageUrl);
	        
	        FightingLayoutBugs flb = new FightingLayoutBugs();
	        
	        // flb.configure(DetectNeedsHorizontalScrolling.class).setMinimalSupportedScreenResolution(800, 600);
	        flb.setScreenshotDir(new File("."));
	        
	        final Collection<LayoutBug> layoutBugs = flb.findLayoutBugsIn(driver);
	        System.out.println("Found " + layoutBugs.size() + " layout bug(s)");
	        for (LayoutBug bug : layoutBugs) {
	            System.out.println(bug);
	        }
	    } catch (Exception e) {
	        e.printStackTrace();
	    } finally {
	        driver.quit();
	    }
	}
}
