	function getElementsByClass(searchClass) {
		var classElements = new Array();
		var els = document.getElementsByTagName("*");
		var elsLen = els.length;
		var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
		for (i = 0, j = 0; i < elsLen; i++) {
			if ( pattern.test(els[i].className) ) {
				classElements[j] = els[i];
				j++;
			}
			
  		}
		return classElements;
	}

	function sortNumber(a,b) {
		return a - b;
	}

	function reset() {
		var anz = getElementsByClass("grade");
		for (var i = 0; i < anz.length; i++) {
			anz[i].value="";
  		}
  		
		anz = getElementsByClass("module");
		for (var j = 0; j < anz.length; j++) {			
  			anz[j].value="";
  		}
  		
  		anz = getElementsByClass("faktor");
		for (var x = 0; x < anz.length; x++) {			
  			anz[x].value="";
  		}
  		
		changeResult(" ");

        anz[15].value="3";
		anz[16].value="3";
		anz[17].value="3";
		anz[18].value="3";
		anz[19].value="3";
		anz[24].value="0";
		anz[25].value="0";
		anz[26].value="0";
		anz[27].value="1";
		anz[28].value="3";
	}
	
	function isFloat(wert) {
		return wert.match(/^[1-4]([,.][0-9])?$/) ? true : false;
	}
  		
  	function changeResult(htmlResult) {
		document.getElementById("ErgebnisFeld").innerHTML = htmlResult;
		window.location.href = "#ErgebnisFeld";
  	}

	function getOrder(moduleGrades) {
		var bestOrder=moduleGrades.slice();
		var newOrder=[];
		var j;
		bestOrder.sort(sortNumber);
		for (var i=0; i < bestOrder.length; i++) {
			j=0;
			while(bestOrder[i]!=moduleGrades[j]) {				
				j++;
			}
			moduleGrades[j]="";
			newOrder[j]=i+1;
		}
		return newOrder;
	}
	
	function fillGrades(moduleName) {
		var grade = document.getElementsByName(moduleName);
		var arGrades = [];
		for(var i=0; i < grade.length; i++) {			
			arGrades[i]=parseFloat(grade[i].value.replace(",", "."));
		}
		return arGrades;
	}

	function fillFactors() {
		var factor = getElementsByClass("faktor");
		var grade = getOrder(fillGrades("gitseGrade"));
		for(var i=0; i<grade.length; i++) {
			factor[i].value=(grade[i] < 4) ? "3" : "0";
			}
        grade = getOrder(fillGrades("soumoGrade"));
        for(var i=0; i<grade.length; i++) {
			factor[i+4].value=(grade[i] < 3) ? "3" : "1";
			}
		grade = getOrder(fillGrades("mutgGrade"));
        for(var i=0; i<grade.length; i++) {
			factor[i+7].value=(grade[i] < 4) ? "1" : "0";
			}
		grade = getOrder(fillGrades("swbsGrade"));
        for(var i=0; i<grade.length; i++) {
			factor[i+11].value=(grade[i] < 4) ? "3" : "1";
			}
		grade = getOrder(fillGrades("rewigGrade"));
        for(var i=0; i<grade.length; i++) {
			factor[i+20].value=(grade[i] < 2) ? "1" : "0";
			}
	}
	
	function testGrades() {
		var anz = getElementsByClass("grade");
		for (var i = 0; i < anz.length; i++) {
			if(isFloat(anz[i].value) == 0) {
				alert("Notenangabe fehlerhaft!"); 
				anz[i].focus();
				return 0;
			}
  		}
  		return 1;
	}

	function calculate() {
		var ergebnis = 0;
		if(testGrades()==1) {
			fillFactors();
			grade = getElementsByClass("grade");
			factor = getElementsByClass("faktor");
			for(var i=0; i<grade.length; i++) {
				ergebnis = ergebnis + (factor[i].value * parseFloat(grade[i].value.replace(",", ".")));
			}
			ergebnis = ergebnis / 49;
			ergebnis = Math.round(ergebnis * 100)/100;
			ergebnis = parseInt(ergebnis*10)/10;
			changeResult("<h2>Der berechnete Bachelor-Schnitt betr&auml;gt " + ergebnis + ".</h2>");
		}
	}